HDU 1298 T9(字典树的经典应用)

T9

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2615 Accepted Submission(s): 976

Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type “hello” you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The “9” in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the “most probable” word matching the input. For example, to enter “hello” you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word “gdjjm”, but since this is no sensible English word, it can safely be ignored. By ruling out all other “improbable” solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.

Figure 8: The Number-keys of a mobile phone.

More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words “idea” and “hello”, with “idea” occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you “i”, “id”, then switches to “hel”, “hell”, and finally shows “hello”.

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words “hell”, “hello”, and “hellfire”, the probability of the character combination “hell” is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word “hello” is in the dictionary, the user can also enter the word “he” by pressing the keys 4 and 3 even if this word is not listed in the dictionary.

Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it’s a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning “next word”.

Output
The output for each scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print “MANUALLY” instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.

Sample Input
2
5
hell 3
hello 4
idea 8
next 8
super 3
2
435561
43321
7
another 5
contest 6
follow 3
give 13
integer 6
new 14
program 4
5
77647261
6391
4681
26684371
77771

Sample Output
Scenario #1:
i
id
hel
hell
hello

i
id
ide
idea

Scenario #2:
p
pr
pro
prog
progr
progra
program

n
ne
new

g
in
int

c
co
con
cont
anoth
anothe
another

p
pr
MANUALLY
MANUALLY

这题想了好久也没想到要怎么建树…….最后还是参考了网上大神的思路。

大概思路是:
1 对给你的每个字符串插入字典树中,并且把他所给你的概率在每个节点的每个字母上相加。
2 运用dfs,也可以是递归或者枚举的思想,每次输入一个输入命令如 435561 那么你就要对每个数字进行搜索看看能否搜索到的最大的概率是多少。

#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <iostream>
#define maxs 100020
#include <string>
#define MME(i,j) memset(i,0,sizeof(i))
using namespace std;
int sum;
string findstr;
char input[110];
int phone[10]={0,0,3,3,3,3,3,4,3,4};//记录不同的按键所对应的字符的个数
char basic[10][5]={"*","*","abc","def","ghi","jkl","mno","pqrs","tuv","wxyz"};//比如2:对于的可能为a b c,要枚举每种情况
typedef struct node
{
    struct node* nexts[26];
    int probability;
    bool exist;
}TrieNode,*Trie;

Trie build_node()
{
    Trie p=new TrieNode;
    MME(p->nexts,0);
    p->exist=false;
    p->probability=0;
    return p;
}//建树

void InsertNode(Trie root,char *s,int pro)
{
    Trie p=root;
    int i=0,id;
    while(s[i])
    {
        id=s[i]-'a';
        if(p->nexts[id]==NULL)
            p->nexts[id]=build_node();

        p=p->nexts[id];

        p->probability +=pro;
        i++;
    }
    p->exist=1;
}//建树(插入字符串)

void find(int k,int len,Trie p,string a)//这里用了string是方便对答案的修改
{
   if(k==len)
   {
       if(p->probability>sum)//当前概率大于之前的概率是
       {
           sum=p->probability;
           findstr=a;//把当前的得到的串赋值
       }
   }
   int t=input[k]-'0';//在input[k]上所表示的数字是多少
   for(int i=0;i<phone[t];i++)//这样就用上了,比如2 就有3个字符 a,b,c(进行枚举)
   {
       if(p->nexts[basic[t][i]-'a'])
            find(k+1,len,p->nexts[basic[t][i]-'a'],a+basic[t][i]);//递归调用 a+basic[t][i]是把这个字符加入到答案中
   }
}
void deleteroot(Trie root)
{
    if(root==NULL)
        return;

    for(int i=0;i<26;i++)
    {
        if(root->nexts[i])
            deleteroot(root->nexts[i]);
    }
    delete root;
}
int main()
{
    int t,wordnum,question;
    scanf("%d",&t);
    for(int tt=1;tt<=t;tt++)
    {
        printf("Scenario #%d:\n",tt);
        Trie root=build_node();
        scanf("%d",&wordnum);
        int len,p;
        for(int i=0;i<wordnum;i++)
        {
            scanf("%s %d",input,&p);
            InsertNode(root,input,p);
        }
        scanf("%d",&question);
        for(int i=0;i<question;i++)
        {
            scanf("%s",input);
            int len=strlen(input);
            for(int j=1;j<len;j++)
            {
                sum=0;
                find(0,j,root,"\0");//枚举每次输入时以不同的数字作为结尾 如234223 那么2 3 能得到什么样的字符.......等等
                if(sum) cout<<findstr<<endl;
                else cout<<"MANUALLY"<<endl;
            }
            cout<<endl;
        }
        cout<<endl;

    }
}

最后 总结就是:还是太菜了,需要更多的练习。现在有些缺少独立思考的能力了。好多题都想不到或者只是想到一半就不会了。大概是因为平时做题时爱看题解的原因吧。以后争取少看题解。不会就放着。希望本篇文章对各位能有所帮助。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值